/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Main.java to edit this template
 */
package tareaproductorbufferconsumidor;

import java.util.ArrayList;

/**
 *
 * @author kyman
 */
public class TareaProductorBufferConsumidor {
    
    // Configuración.
    private static final int longitud_limite_producto = 15;
    private static final int longitud_maxima_buffer = 6;
    // Configuración.
    
    private static boolean trabajando = true;
    private static final ArrayList<String> buffer = new ArrayList<>();

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        
        new Thread(new Runnable(){
            @Override
            public void run() {
                
                String producto = "";
                
                while(trabajando && producto.length() < longitud_limite_producto)
                    if(!buffer.isEmpty()){
                        
                        String caracter = buffer.remove(0);
                        
                        producto += caracter;
                        System.out.println("Utilizado el caracter '" + caracter + "'.");
                        
                        if(producto.length() == longitud_limite_producto)
                            trabajando = false;
                        
                    }
                
                System.out.println("El productor terminó su tarea con el producto '" + producto + "'.");
                
            }
        }).start();
        
        new Thread(new Runnable(){
            @Override
            public void run() {
                while(trabajando)
                    if(buffer.size() < longitud_maxima_buffer){
                        
                        String caracter = String.valueOf((char)(65 + (int)(Math.random() * 26)));
                        
                        buffer.add(caracter);
                        System.out.println("Añadido el nuevo caracter '" + caracter + "'.");
                        
                    }
            }
        }).start();
        
    }
    
}
